[Arrays] Remove Element

Date:     Updated:

Categories:

Tags:

📋 This is my note-taking from what I learned in LeetCode!


Problem

Problem Link

Given an integer array nums and an integer val, remove all occurrences of val in nums in-place. The order of the elements may be changed. Then return the number of elements in nums which are not equal to val.

Consider the number of elements in nums which are not equal to val be k, to get accepted, you need to do the following things:

  • Change the array nums such that the first k elements of nums contain the elements which are not equal to val. The remaining elements of nums are not important as well as the size of nums.
  • Return k.

Custom Judge:

The judge will test your solution with the following code:

int[] nums = [...]; // Input array
int val = ...; // Value to remove
int[] expectedNums = [...]; // The expected answer with correct length.
                            // It is sorted with no values equaling val.

int k = removeElement(nums, val); // Calls your implementation

assert k == expectedNums.length;
sort(nums, 0, k); // Sort the first k elements of nums
for (int i = 0; i < actualLength; i++) {
    assert nums[i] == expectedNums[i];
}

If all assertions pass, then your solution will be accepted.

Example 1:

  • Input: nums = [3,2,2,3], val = 3
  • Output: 2, nums = [2,2,,]
  • Explanation: Your function should return k = 2, with the first two elements of nums being 2. It does not matter what you leave beyond the returned k (hence they are underscores).

Example 2:

  • Input: nums = [0,1,2,2,3,0,4,2], val = 2
  • Output: 5, nums = [0,1,4,0,3,,,_]
  • Explanation: Your function should return k = 5, with the first five elements of nums containing 0, 0, 1, 3, and 4. Note that the five elements can be returned in any order. It does not matter what you leave beyond the returned k (hence they are underscores).

Constraints:

  • 0 <= nums.length <= 100
  • 0 <= nums[i] <= 50
  • 0 <= val <= 100

Hint #1:

The problem statement clearly asks us to modify the array in-place and it also says that the element beyond the new length of the array can be anything. Given an element, we need to remove all the occurrences of it from the array. We don’t technically need to remove that element per-say, right?

Hint #2:

We can move all the occurrences of this element to the end of the array. Use two pointers! Image

Hint #3:

Yet another direction of thought is to consider the elements to be removed as non-existent. In a single pass, if we keep copying the visible elements in-place, that should also solve this problem for us.


Solution

Solution Link

Hints:

  1. Try two pointers.
  2. Did you use the fact that the order of elements can be changed?
  3. What happens when the elements to remove are rare?

Approach 1: Two Pointers

Algorithm:

  1. When nums[j] equals to the given value, skip this element by incrementing j.
  2. As long as nums[j] ≠ val, we copy nums[j] to nums[i] and increment both indexes at the same time.
  3. Repeat the process until j reaches the end of the array and the new length is i.

→ This solution is very similar to the solution to “Remove Duplicates from Sorted Array”.

def removeElement(nums: list[int], val: int) -> int:
    i = 0
    for j in range(len(nums)):
        if nums[j] != val:
            nums[i] = nums[j]
            i += 1
    return i


nums = [3, 2, 2, 3]
val = 3
result = removeElement(nums, val)
print(result)
print(nums[:result])

Complexity Analysis

  • Time complexity : O(n). Assume the array has a total of nnn elements, both i and j traverse at most 2n steps.
  • Space complexity : O(1).


Approach 2: Two Pointers - when elements to remove are rare

Algorithm:

  1. When we encounter nums[i]=val, we can swap the current element out with the last element and dispose the last one. → This essentially reduces the array’s size by 1.

Note that the last element that was swapped in could be the value you want to remove itself. But don’t worry, in the next iteration we will still check this element.

def removeElement(nums: list[int], val: int) -> int:
    i = 0
    n = len(nums)
    while i < n:
        if nums[i] == val:
            nums[i] = nums[n - 1]
            n -= 1
        else:
            i += 1
    return n


nums = [3, 2, 2, 3]
val = 3
result = removeElement(nums, val)
print(result)
print(nums[:result])

Complexity Analysis

  • Time complexity : O(n). Both i and n traverse at most nnn steps. In this approach, the number of assignment operations is equal to the number of elements to remove. So it is more efficient if elements to remove are rare.
  • Space complexity : O(1).




Back to Top

See other articles in Category Arrays

Leave a comment